using Microsoft.VisualBasic;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.Diagnostics;
using System.Windows.Forms;
using System.Linq;
using System.Xml.Linq;
using System.Runtime.InteropServices;
namespace TelerikWinFormsApp10
{
    //https://msdn.microsoft.com/en-us/library/ms996492.aspx
	public class RTFRenderer
	{
private const int SB_VERT = 1;
        
        // variable to trace text to print for pagination
        private int m_nFirstCharOnPage;
        
        static readonly Microsoft.VisualBasic.CompilerServices.StaticLocalInitFlag static_DrawRTF_rtfDrawer_Init = new Microsoft.VisualBasic.CompilerServices.StaticLocalInitFlag();
		static RichTextBoxRenderer static_DrawRTF_rtfDrawer;
		//Converted to vb.net from http://andrewvos.com/2008/05/23/draw-rtf-text-on-a-graphics-object-in-c/
        /// <summary>
        /// 
        /// </summary>
        /// <param name="measureOnly">If true, only the calculation is performed, otherwise the text is rendered as well</param>
        /// <param name="g"></param>
        /// <param name="rtf"></param>
        /// <param name="layoutArea"></param>
        /// <param name="backColor"></param>
        /// <returns>true if there are more pages to print otherwise false</returns>
		public static bool DrawOrMeasureRTF(bool measureOnly, Graphics g, string rtf, Rectangle layoutArea, Color backColor, out int maxScroll, out int scrollPos)
		{
			lock (static_DrawRTF_rtfDrawer_Init) {
				try {
					if (InitStaticVariableHelper(static_DrawRTF_rtfDrawer_Init)) {
						static_DrawRTF_rtfDrawer = new RichTextBoxRenderer();
					}
				} finally {
					static_DrawRTF_rtfDrawer_Init.State = 1;
				}
			}
			static_DrawRTF_rtfDrawer.Rtf = rtf;
			static_DrawRTF_rtfDrawer.BackColor = backColor;

            static_DrawRTF_rtfDrawer.SelectionStart = static_DrawRTF_rtfDrawer.Text.Length;
            static_DrawRTF_rtfDrawer.ScrollToCaret();

//static_DrawRTF_rtfDrawer.ReachedBottom();
            int a = static_DrawRTF_rtfDrawer.maxScrollFromGetScrollInfo();

            int pointY;
            maxScroll = static_DrawRTF_rtfDrawer.getMaxScroll(out pointY);
            scrollPos = pointY;
//static_DrawRTF_rtfDrawer.GetScrollRange(static_DrawRTF_rtfDrawer.Handle, SB_VERT, out minScroll, out maxScroll);
            int nrOfRenderedChars = static_DrawRTF_rtfDrawer.Draw(measureOnly, g, layoutArea);
    
            int m_nFirstCharOnPage = 0;

            // check if there are more pages to print
            if ( (nrOfRenderedChars - m_nFirstCharOnPage) < static_DrawRTF_rtfDrawer.TextLength)
                return true; // has more pages
            else
                return false; //does not have more pages
		}

        public static bool DrawOrMeasureRTF(bool measureOnly, Graphics g, string rtf, Rectangle layoutArea, Color backColor)
        {
            int tempMaxScroll; int tempScrlPos;
            return (DrawOrMeasureRTF(measureOnly, g, rtf, layoutArea, backColor, out tempMaxScroll, out tempScrlPos));
            
        }

		private class RichTextBoxRenderer : RichTextBox
		{
            //http://www.pinvoke.net/default.aspx/Structures/POINT.html
            [StructLayout(LayoutKind.Sequential)]
            public struct POINT
            {
                public int X;
                public int Y;

                public POINT(int x, int y)
                {
                    this.X = x;
                    this.Y = y;
                }

                public POINT(System.Drawing.Point pt) : this(pt.X, pt.Y) { }

                public static implicit operator System.Drawing.Point(POINT p)
                {
                    return new System.Drawing.Point(p.X, p.Y);
                }

                public static implicit operator POINT(System.Drawing.Point p)
                {
                    return new POINT(p.X, p.Y);
                }
            }

            private const int SB_VERT = 1;
            private const int WM_USER = 0x400;
            private const int EM_SETSCROLLPOS = WM_USER + 222;
            private const int EM_GETSCROLLPOS = WM_USER + 221;
            public int getMaxScroll(out int pointY) //http://stackoverflow.com/questions/10237781/get-current-scroll-position-from-rich-text-box-control
            {
                int minScroll;
                int maxScroll;
                GetScrollRange(this.Handle, SB_VERT, out minScroll, out maxScroll);
                //Point rtfPoint = Point.Empty;
                Point p = new Point();
                //http://stackoverflow.com/questions/22757536/obtain-scroll-bar-position-in-richtextbox-with-scroll-bars-disabled
                var ptr = Marshal.AllocHGlobal(Marshal.SizeOf(typeof(POINT)));
                Marshal.StructureToPtr(new POINT(), ptr, false);
                SafeNativeMethods.SendMessage(this.Handle, EM_GETSCROLLPOS, IntPtr.Zero, ref p);
                var point = (POINT)Marshal.PtrToStructure(ptr, typeof(POINT));
                pointY=point.Y;
                Marshal.FreeHGlobal(ptr);
                //return (rtfPoint.Y + this.ClientSize.Height >= maxScroll);
                Console.WriteLine(maxScroll.ToString() /*+ " "+rtfPoint.Y.ToString() */);
                return (maxScroll);
            }

			//Code converted from code found here: http://support.microsoft.com/kb/812425/en-us
			public int Draw(bool measureOnly, Graphics g, Rectangle layoutArea)
			{
				var xFrac = 1440 / g.DpiX;
				var yFrac = 1440 / g.DpiY;

				//Convert the layoutArea from pixels to twips
				SafeNativeMethods.RECT rectLayoutArea = default(SafeNativeMethods.RECT);
				rectLayoutArea.Top = Convert.ToInt32(layoutArea.Top * yFrac);
				rectLayoutArea.Bottom = Convert.ToInt32(layoutArea.Bottom * yFrac);
				rectLayoutArea.Left = Convert.ToInt32(layoutArea.Left * xFrac);
				rectLayoutArea.Right = Convert.ToInt32(layoutArea.Right * xFrac);

				var hdc = g.GetHdc();

				SafeNativeMethods.FORMATRANGE fmtRange = default(SafeNativeMethods.FORMATRANGE);
				fmtRange.chrg.cpMax = -1;
				//Indicate character from to character to 
				fmtRange.chrg.cpMin = 0;
				fmtRange.hdc = hdc;
				//Use the same DC for measuring and rendering
				fmtRange.hdcTarget = hdc;
				//Point at printer hDC
				fmtRange.rc = rectLayoutArea;
				//Indicate the area on page to print
				fmtRange.rcPage = rectLayoutArea;
				//Indicate size of page

				//Get the pointer to the FORMATRANGE structure in memory
				var lParam = Marshal.AllocCoTaskMem(Marshal.SizeOf(fmtRange));
				Marshal.StructureToPtr(fmtRange, lParam, false);

                var wParam = new IntPtr(measureOnly ? 0 : 1);     // for wParam the Non-Zero wParam means render, Zero means measure
                
				//Non-zero = Render the text, zero = measure the text
                IntPtr res = IntPtr.Zero;
				res = SafeNativeMethods.SendMessage(this.Handle, SafeNativeMethods.EM_FORMATRANGE, wParam, lParam);

				//Free the block of memory allocated
				Marshal.FreeCoTaskMem(lParam);

				//Release the device context handle obtained by a previous call
				g.ReleaseHdc(hdc);
                return res.ToInt32();
			}

			private class SafeNativeMethods
			{
				[DllImport("user32.dll", SetLastError = true, CharSet = CharSet.Auto)]
				public static extern IntPtr SendMessage(IntPtr hWnd, uint Msg, IntPtr wParam, IntPtr lParam);

                [DllImport("user32.dll", SetLastError = true, CharSet = CharSet.Auto)]
                public static extern int SendMessage(IntPtr hWnd, int wMsg, IntPtr wParam, ref Point lParam);

                //[DllImport("user32.dll", SetLastError = true, CharSet = CharSet.Auto)]
                //public static extern IntPtr SendMessage(IntPtr hWnd, Int32 wMsg, Int32 wParam, ref Point lParam);

				[DllImport("kernel32.dll", SetLastError = true, CharSet = CharSet.Ansi)]
				public static extern IntPtr LoadLibrary(string lpFileName);

				[StructLayout(LayoutKind.Sequential)]
				public struct RECT
				{
					public int Left;
					public int Top;
					public int Right;
					public int Bottom;
				}

				[StructLayout(LayoutKind.Sequential)]
				public struct CHARRANGE
				{
						//First character of range (0 for start of doc)
					public int cpMin;
						//Last character of range (-1 for end of doc)
					public int cpMax;
				}

				[StructLayout(LayoutKind.Sequential)]
				public struct FORMATRANGE
				{
						//Actual DC to draw on
					public IntPtr hdc;
						//Target DC for determining text formatting
					public IntPtr hdcTarget;
						//Region of the DC to draw to (in twips)
					public RECT rc;
						//Region of the whole DC (page size) (in twips)
					public RECT rcPage;
						//Range of text to draw (see earlier declaration)
					public CHARRANGE chrg;
				}

				public const int  WM_USER = 0x400;
				public const int EM_FORMATRANGE = WM_USER + 57;

                /* start http://stackoverflow.com/questions/2364970/measure-string-inside-richtextbox-control */
                /// <summary>
                /// https://msdn.microsoft.com/en-us/library/windows/desktop/bb787535%28v=vs.85%29.aspx
                /// </summary>
                [StructLayout(LayoutKind.Sequential)]
                public struct SCROLLBARINFO
                {
                    public Int32 cbSize;        //Type: DWORD  Specifies the size, in bytes, of the structure. Before calling the GetScrollBarInfo function, set cbSize to sizeof(SCROLLBARINFO).
                    public SafeNativeMethods.RECT rcScrollBar;    //Type: RECT   Coordinates of the scroll bar as specified in a RECT structure.
                    public Int32 dxyLineButton; //Type: int    Height or width of the thumb.
                    public Int32 xyThumbTop;    //Type: int    Position of the top or left of the thumb.
                    public Int32 xyThumbBottom; //Type: int    Position of the bottom or right of the thumb.
                    public Int32 reserved;      //Type: int    Reserved.
                    [MarshalAs(UnmanagedType.ByValArray, SizeConst = 6)]
                    public Int32[] rgstate;     //Type: DWORD[CCHILDREN_SCROLLBAR+1]    An array of DWORD elements. Each element indicates the state of a scroll bar component. The following values show the scroll bar component that corresponds to each array index. 
                    //    0	The scroll bar itself.
                    //    1	The top or right arrow button.
                    //    2	The page up or page right region.
                    //    3	The scroll box (thumb).
                    //    4	The page down or page left region.
                    //    5	The bottom or left arrow button.
                    // The DWORD element for each scroll bar component can include a combination of the following bit flags.
                    // Value	Meaning
                    // STATE_SYSTEM_INVISIBLE For the scroll bar itself, indicates the specified vertical or horizontal scroll bar does not exist. For the page up or page down regions, indicates the thumb is positioned such that the region does not exist.
                    // STATE_SYSTEM_OFFSCREEN For the scroll bar itself, indicates the window is sized such that the specified vertical or horizontal scroll bar is not currently displayed.
                    // STATE_SYSTEM_PRESSED The arrow button or page region is pressed.
                    // STATE_SYSTEM_UNAVAILABLE The component is disabled.
                }

                private UInt32 SB_VERT = 1;
                private UInt32 OBJID_VSCROLL = 0xFFFFFFFB;


                /// <summary>
                /// The GetScrollBarInfo function retrieves information about the specified scroll bar.
                /// </summary>
                /// <param name="hWnd">Handle to a window associated with the scroll bar whose information is to be retrieved. If the idObject parameter is OBJID_CLIENT, hwnd is a handle to a scroll bar control. Otherwise, hwnd is a handle to a window created with WS_VSCROLL and/or WS_HSCROLL style. </param>
                /// <param name="idObject">Specifies the scroll bar object. This parameter can be one of the following values.
                /// Value: OBJID_CLIENT  Meaning: The hwnd parameter is a handle to a scroll bar control.
                /// Value: OBJID_HSCROLL Meaning: The horizontal scroll bar of the hwnd window.
                /// Value: OBJID_VSCROLL Meaning: The vertical scroll bar of the hwnd window.</param>
                /// <param name="psbi">Pointer to a SCROLLBARINFO structure to receive the information. Before calling GetScrollBarInfo, set the cbSize member to sizeof(SCROLLBARINFO).</param>
                /// <returns>If the function succeeds, the return value is nonzero. 
                /// If the function fails, the return value is zero. To get extended error information, call GetLastError.</returns>
                [DllImport("user32.dll")]
                /*private*/
                public static extern
                    Int32 GetScrollBarInfo(IntPtr hWnd, UInt32 idObject, ref SCROLLBARINFO psbi); //https://msdn.microsoft.com/en-us/library/windows/desktop/bb787581%28v=vs.85%29.aspx
                /* end http://stackoverflow.com/questions/2364970/measure-string-inside-richtextbox-control */

                /* start http://stackoverflow.com/questions/19343794/how-to-know-if-richtextbox-vertical-scrollbar-reached-the-max-value */
                [DllImport("user32")]
                /*private*/
                public static extern int GetScrollInfo(IntPtr hwnd, int nBar,
                                            ref SCROLLINFO scrollInfo);

                [StructLayout(LayoutKind.Sequential)]
                public struct SCROLLINFO
                {
                    public int cbSize;
                    public int fMask;
                    public int min;
                    public int max;
                    public int nPage;
                    public int nPos;
                    public int nTrackPos;
                }
                /* end http://stackoverflow.com/questions/19343794/how-to-know-if-richtextbox-vertical-scrollbar-reached-the-max-value */


			}

            /// <summary>
            /// http://stackoverflow.com/questions/19343794/how-to-know-if-richtextbox-vertical-scrollbar-reached-the-max-value
            /// </summary>
            /// <returns></returns>
            public /*static*/ bool ReachedBottom(/*this RichTextBox rtb*/)
            {
                SafeNativeMethods.SCROLLINFO scrollInfo = new SafeNativeMethods.SCROLLINFO();
                scrollInfo.cbSize = Marshal.SizeOf(scrollInfo);
                //SIF_RANGE = 0x1, SIF_TRACKPOS = 0x10,  SIF_PAGE= 0x2
                scrollInfo.fMask = 0x10 | 0x1 | 0x2;
                SafeNativeMethods.GetScrollInfo(this.Handle, 1, ref scrollInfo);//nBar = 1 -> VScrollbar
                return scrollInfo.max == scrollInfo.nTrackPos + scrollInfo.nPage;
            }

            public /*static*/ int maxScrollFromGetScrollInfo(/*this RichTextBox rtb*/)
            {
                SafeNativeMethods.SCROLLINFO scrollInfo = new SafeNativeMethods.SCROLLINFO();
                scrollInfo.cbSize = Marshal.SizeOf(scrollInfo);
                //SIF_RANGE = 0x1, SIF_TRACKPOS = 0x10,  SIF_PAGE= 0x2
                scrollInfo.fMask = 0x10 | 0x1 | 0x2;
                SafeNativeMethods.GetScrollInfo(this.Handle, 1, ref scrollInfo);//nBar = 1 -> VScrollbar
                return (scrollInfo.max);
            }


            /// <summary>
            /// https://msdn.microsoft.com/en-us/library/windows/desktop/bb787587%28v=vs.85%29.aspx
            /// </summary>
            /// <param name="hWnd">Handle to a scroll bar control or a window with a standard scroll bar, depending on the value of the nBar parameter. </param>
            /// <param name="nBar">Specifies the scroll bar from which the positions are retrieved. This parameter can be one of the following values. 
            /// Value	Meaning
            ///   SB_CTL Retrieves the positions of a scroll bar control. The hWnd parameter must be the handle to the scroll bar control.
            ///   SB_HORZ Retrieves the positions of the window's standard horizontal scroll bar.
            ///   SB_VERT Retrieves the positions of the window's standard vertical scroll bar.</param>
            /// <param name="lpMinPos">Pointer to the integer variable that receives the minimum position. </param>
            /// <param name="lpMaxPos">Pointer to the integer variable that receives the maximum position. </param>
            /// <returns>If the function succeeds, the return value is nonzero. If the function fails, the return value is zero. To get extended error information, call GetLastError. </returns>
            [DllImport("user32.dll")]
            /*private*/
            public static extern
                Int32 GetScrollRange(IntPtr hWnd, UInt32 nBar, out Int32 lpMinPos, out Int32 lpMaxPos);

        }
		static bool InitStaticVariableHelper(Microsoft.VisualBasic.CompilerServices.StaticLocalInitFlag flag)
		{
			if (flag.State == 0) {
				flag.State = 2;
				return true;
			} else if (flag.State == 2) {
				throw new Microsoft.VisualBasic.CompilerServices.IncompleteInitialization();
			} else {
				return false;
			}
		}
	}
}
